#include "delay.h"
#include "global_param.h"

G_Type_t g_timer;

/*System Tick Configuration ----------------------------------------*/


/*******************************************************************************
*                           @2017-12-16
* Function Name  : delay_init
* Description    : 延时函数初始化
* Input          : none
* Output         : none
* Return         : none
*                  SYSTICK的时钟固定为HCLK时钟的1/8
*                  SYSCLK:系统时钟
*******************************************************************************/
u8  fac_us=0;//us延时倍乘数
u16 fac_ms=0;//ms延时倍乘数
void Systick_Init(void)
{
	#if 0
	SysTick->CTRL = 0x07;
	SysTick->LOAD  = (uint32_t)((SystemCoreClock / 10000u) - 1UL);  /* set reload register */
	SysTick->VAL   = 0UL;                                       /* Load the SysTick Counter Value */
	
	fac_us=SystemCoreClock/8000000;
	#endif
	SysTick_Config(SystemCoreClock / 1000); //1ms
//	SysTick_CLKSourceConfig(SysTick_CLKSource_HCLK_Div8);	//选择外部时钟  HCLK/8
	
	fac_us=SystemCoreClock/8000000;	//为系统时钟的1/8  
	fac_ms=(u16)fac_us*1000;//非ucos下,代表每个ms需要的systick时钟数   

}

/*-------------------Disable System Tick  ----------------------------------------*/
void Disable_Systick(void)
{
	STK_CVR=0; //set counter to zero
	STK_RVR &=~ SYSTICK_RELOAD; //Reload Register，20 ms Interrupt
	STK_CSR &=~ 0x07;// HCLK as system tick time source, interrupt enable , system tick enable
}

void System_BaseTime_Update(void)
{
	g_timer.time++;
}

uint32_t System_Get_Time(void)
{
	return g_timer.time;
}
#if RT_THREAD
#include "rtthread.h"
#endif
void Timer_Delay_Ms(uint16_t ms)
{
	#if RT_THREAD
	rt_thread_delay(ms);		
	#else
	uint32_t start_time = g_timer.time;
	while(1)
	{
		if (g_timer.time >= (start_time + ms*TIME_1MS))
		{
			break;
		}
	}
	#endif
}
//that will return width if the time reach
int32_t Timer_Is_TimeReach(uint32_t *pre_time,uint32_t width)
{
	uint32_t delta_time;
	
	if (g_timer.time >= (*pre_time + width))
	{
		delta_time = g_timer.time - *pre_time;;
		*pre_time = g_timer.time;
		return delta_time;
	}
	else if (g_timer.time < *pre_time)	//overflow Waiting modify
	{
		*pre_time = g_timer.time;
		return width;
	}
	return 0;
}
int32_t Timer_Is_TimeReach_No_Repeat(uint32_t *pre_time,uint32_t width)
{	
	if (g_timer.time >= (*pre_time + width))
	{
		return 1;
	}
	else if (g_timer.time < *pre_time)	//overflow Waiting modify
	{
		*pre_time = g_timer.time;
		return width;
	}
	return 0;
}

uint32_t Timer_Get_DiffNow(uint32_t start)
{
//	LOG("start:%d,time:%d,abs:%d\n",start,system.time,Timer_abs(system.time,start));
	return g_timer.time-start;//Timer_abs(g_timer.time,start);
}

						    
