/******************************************************************************
**************************Hardware interface layer*****************************
* | file      	:	LD3320_Config.c
* |	version			:	V1.0
* | date				:	2020-06-18
* | function		:	Provide the hardware underlying interface	
******************************************************************************/
#include "LD3320_Config.h"

/********************************************************************************
function:	
				SPI send data
********************************************************************************/
#define I2C_TIMEOUT                               0xF0
uint32_t I2C_Timeout;
UBYTE spi_send_byte(UBYTE value)
{
//    __HAL_SPI_ENABLE(&hspi1);
	SPI1->CR1 |= SPI_CR1_SPE;
    SPI1->CR2 |= (1) << 12;
	
	I2C_Timeout = I2C_TIMEOUT;

    while((SPI1->SR & (1 << 1)) == 0)
	{
		if((I2C_Timeout--) == 0)
		{
		  return false;
		}		
	}
        

    *((__IO uint8_t *)(&SPI1->DR)) = value;

	
	I2C_Timeout = I2C_TIMEOUT;
    while(SPI1->SR & (1 << 7))  //Wait for not busy
	{
		if((I2C_Timeout--) == 0)
		{
		  return false;
		}		
	}

	I2C_Timeout = I2C_TIMEOUT;
    while((SPI1->SR & (1 << 0)) == 0)  // Wait for the receiving area to be empty
	{
		if((I2C_Timeout--) == 0)
		{
		  return false;
		}		
	}
    return *((__IO uint8_t *)(&SPI1->DR));
}

/********************************************************************************
function:		
				Delay 
********************************************************************************/
void Driver_Delay_ms(uint32_t xms)
{
	Timer_Delay_Ms(xms);
}

