#ifndef __hal_adc_
#define __hal_adc_ 			   
#ifdef __cplusplus
extern "C" {
#endif
#include "global_param.h"
typedef struct{
	volatile uint16_t Charge_A_Voltage;  
	volatile uint16_t Charge_B_Voltage;  
	volatile uint16_t Main_Brush_Current;	
	volatile uint16_t Charge_B_Current;    
	volatile uint16_t Charge_A_Current;    
	volatile uint16_t Right_Wheel_Current;
	volatile uint16_t Right_Brush_Current;    	
	volatile uint16_t Vbat_A_temperature;    
	volatile uint16_t Vbat_B_temperature;  
	volatile uint16_t Left_Wheel_Current;
	volatile uint16_t Left_Brush_Current; 
	volatile uint16_t Vacuum_Current;
   
}ADC_Value_t;

#define ADC_DR_ABS_VAL      20    /*ADC采集变化偏差绝对值*/

void Hal_Adc_Init(void); //初始化ADC1
void AdcRead(void);

short Get_Temprate(void);			//获取内部温度传感器温度值

#ifdef __cplusplus
}
#endif
#endif

