#include "hal_driving_wheel.h"
#include "driving_wheel.h"
#include "usart.h"
#include "delay.h"
#include "global_param.h"

#define TIMER_40K_ARR               7199  
#define TIMER_40K_PSC               0 

#define MCU_AW_DIR_IN1_GPIO    GPIOE
#define MCU_AW_DIR_IN1_PIN	   GPIO_Pin_2

#define MCU_AW_DIR_IN2_GPIO    GPIOE
#define MCU_AW_DIR_IN2_PIN     GPIO_Pin_3

#define MCU_AW_DIR_FORWORD   	GPIO_SetBits(MCU_AW_DIR_IN1_GPIO,MCU_AW_DIR_IN1_PIN);\
							   	GPIO_ResetBits(MCU_AW_DIR_IN2_GPIO,MCU_AW_DIR_IN2_PIN);	
								
#define MCU_AW_DIR_BACKWORD	   	GPIO_ResetBits(MCU_AW_DIR_IN1_GPIO,MCU_AW_DIR_IN1_PIN);\
								GPIO_SetBits(MCU_AW_DIR_IN2_GPIO,MCU_AW_DIR_IN2_PIN);	


#define MCU_AW_DIR_STOP	   	GPIO_ResetBits(MCU_AW_DIR_IN1_GPIO,MCU_AW_DIR_IN1_PIN);\
								GPIO_ResetBits(MCU_AW_DIR_IN2_GPIO,MCU_AW_DIR_IN2_PIN);	
#define MCU_AW_TIM_CH     TIM1->CCR1
/****************************************************************/
#define MCU_BW_DIR_IN1_GPIO    GPIOE
#define MCU_BW_DIR_IN1_PIN	   GPIO_Pin_4

#define MCU_BW_DIR_IN2_GPIO    GPIOE
#define MCU_BW_DIR_IN2_PIN     GPIO_Pin_5

#define MCU_BW_DIR_FORWORD   	GPIO_SetBits(MCU_BW_DIR_IN1_GPIO,MCU_BW_DIR_IN1_PIN);\
							   	GPIO_ResetBits(MCU_BW_DIR_IN2_GPIO,MCU_BW_DIR_IN2_PIN);	
								
#define MCU_BW_DIR_BACKWORD	   	GPIO_ResetBits(MCU_BW_DIR_IN1_GPIO,MCU_BW_DIR_IN1_PIN);\
								GPIO_SetBits(MCU_BW_DIR_IN2_GPIO,MCU_BW_DIR_IN2_PIN);	

#define MCU_BW_DIR_STOP	   	GPIO_ResetBits(MCU_BW_DIR_IN1_GPIO,MCU_BW_DIR_IN1_PIN);\
								GPIO_ResetBits(MCU_BW_DIR_IN2_GPIO,MCU_BW_DIR_IN2_PIN);	
#define MCU_BW_TIM_CH     TIM1->CCR2
/****************************************************************/
#define MCU_CW_DIR_IN1_GPIO    GPIOE
#define MCU_CW_DIR_IN1_PIN	   GPIO_Pin_6

#define MCU_CW_DIR_IN2_GPIO    GPIOE
#define MCU_CW_DIR_IN2_PIN     GPIO_Pin_7

#define MCU_CW_DIR_FORWORD   	GPIO_SetBits(MCU_CW_DIR_IN1_GPIO,MCU_CW_DIR_IN1_PIN);\
							   	GPIO_ResetBits(MCU_CW_DIR_IN2_GPIO,MCU_CW_DIR_IN2_PIN);	
								
#define MCU_CW_DIR_BACKWORD	   	GPIO_ResetBits(MCU_CW_DIR_IN1_GPIO,MCU_CW_DIR_IN1_PIN);\
								GPIO_SetBits(MCU_CW_DIR_IN2_GPIO,MCU_CW_DIR_IN2_PIN);	

#define MCU_CW_DIR_STOP	   	GPIO_ResetBits(MCU_CW_DIR_IN1_GPIO,MCU_CW_DIR_IN1_PIN);\
								GPIO_ResetBits(MCU_CW_DIR_IN2_GPIO,MCU_CW_DIR_IN2_PIN);
#define MCU_CW_TIM_CH     TIM1->CCR3
/****************************************************************/
Encoder_t g_wheel_a,g_wheel_b,g_wheel_c;
uint8_t g_a_disable = 0,g_b_disable = 0,g_c_disable = 0;
static void Hal_Encode_A_Exit_Config(void)
{
	EXTI_InitTypeDef   EXTI_InitStructure;
	GPIO_InitTypeDef   GPIO_InitStructure;
	NVIC_InitTypeDef   NVIC_InitStructure;

	//PA15 A PA2 B PC6 C
	/* Enable GPIOB clock */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);	
	/* Enable AFIO clock */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);
	//初始化INT管脚 PC0  
	GPIO_PinRemapConfig(GPIO_Remap_SWJ_JTAGDisable,ENABLE);
	/* Configure PC0 pin as input floating */
	GPIO_InitStructure.GPIO_Pin 	= GPIO_Pin_15;
	GPIO_InitStructure.GPIO_Mode 	= GPIO_Mode_IN_FLOATING;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	/* Connect EXTI0 Line to PA15 pin */
	GPIO_EXTILineConfig(GPIO_PortSourceGPIOA, GPIO_PinSource15);

	/* Configure EXTI0 line */
	EXTI_InitStructure.EXTI_Line 		= EXTI_Line15;
	EXTI_InitStructure.EXTI_Mode 		= EXTI_Mode_Interrupt;
	EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;  //下降沿
	EXTI_InitStructure.EXTI_LineCmd = ENABLE;
	EXTI_Init(&EXTI_InitStructure);

	/* Enable and set EXTI Interrupt to the  priority */
	NVIC_InitStructure.NVIC_IRQChannel = EXTI15_10_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0x0F;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x0F;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
}
static void Hal_Encode_B_Exit_Config(void)
{
	EXTI_InitTypeDef   EXTI_InitStructure;
	GPIO_InitTypeDef   GPIO_InitStructure;
	NVIC_InitTypeDef   NVIC_InitStructure;

	//PA15 A PA2 B PC6 C
	/* Enable GPIOB clock */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);	
	/* Enable AFIO clock */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);

	/* Configure PC0 pin as input floating */
	GPIO_InitStructure.GPIO_Pin 	= GPIO_Pin_2;
	GPIO_InitStructure.GPIO_Mode 	= GPIO_Mode_IN_FLOATING;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	/* Connect EXTI0 Line to PA15 pin */
	GPIO_EXTILineConfig(GPIO_PortSourceGPIOA, GPIO_PinSource2);

	/* Configure EXTI0 line */
	EXTI_InitStructure.EXTI_Line 		= EXTI_Line2;
	EXTI_InitStructure.EXTI_Mode 		= EXTI_Mode_Interrupt;
	EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;  //下降沿
	EXTI_InitStructure.EXTI_LineCmd = ENABLE;
	EXTI_Init(&EXTI_InitStructure);

	/* Enable and set EXTI Interrupt to the  priority */
	NVIC_InitStructure.NVIC_IRQChannel = EXTI2_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0x0F;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x0F;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
}
static void Hal_Encode_C_Exit_Config(void)
{
	EXTI_InitTypeDef   EXTI_InitStructure;
	GPIO_InitTypeDef   GPIO_InitStructure;
	NVIC_InitTypeDef   NVIC_InitStructure;

	//PA15 A PA2 B PC6 C
	/* Enable GPIOB clock */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);	
	/* Enable AFIO clock */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);
	/* Configure PC0 pin as input floating */
	GPIO_InitStructure.GPIO_Pin 	= GPIO_Pin_6;
	GPIO_InitStructure.GPIO_Mode 	= GPIO_Mode_IN_FLOATING;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOC, &GPIO_InitStructure);

	/* Connect EXTI0 Line to PA15 pin */
	GPIO_EXTILineConfig(GPIO_PortSourceGPIOC, GPIO_PinSource6);

	/* Configure EXTI0 line */
	EXTI_InitStructure.EXTI_Line 		= EXTI_Line6;
	EXTI_InitStructure.EXTI_Mode 		= EXTI_Mode_Interrupt;
	EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;  //下降沿
	EXTI_InitStructure.EXTI_LineCmd = ENABLE;
	EXTI_Init(&EXTI_InitStructure);

	/* Enable and set EXTI Interrupt to the  priority */
	NVIC_InitStructure.NVIC_IRQChannel = EXTI9_5_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0x0F;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x0F;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
}

static void Hal_Encode_Exit_Config(void)
{
	Hal_Encode_A_Exit_Config();
	Hal_Encode_B_Exit_Config();
	Hal_Encode_C_Exit_Config();
}
void Encode_Exit_Config_Disable(void) 
{
	EXTI_InitTypeDef   EXTI_InitStructure;
	
	/* Configure EXTI0 line */
	EXTI_InitStructure.EXTI_Line 		= EXTI_Line15;
	EXTI_InitStructure.EXTI_Mode 		= EXTI_Mode_Interrupt;
	EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;  //下降沿
	EXTI_InitStructure.EXTI_LineCmd = DISABLE; /*关闭中断*/
	EXTI_Init(&EXTI_InitStructure);
}

void Encode_Exit_Config_Enable(void) 
{
	EXTI_InitTypeDef   EXTI_InitStructure;

	/* Configure EXTI0 line */
	EXTI_InitStructure.EXTI_Line 		= EXTI_Line15;
	EXTI_InitStructure.EXTI_Mode 		= EXTI_Mode_Interrupt;
	EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;  //下降沿
	EXTI_InitStructure.EXTI_LineCmd = ENABLE; /*关闭中断*/
	EXTI_Init(&EXTI_InitStructure);
}
void Hal_Driving_IO_Init(void)
{
	GPIO_InitTypeDef  GPIO_InitStructure;
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOE,ENABLE);
	//E0 E1 为电机的stby 引脚	

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1;				 
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;		 //IO口速度为50MHz
	GPIO_Init(GPIOE, &GPIO_InitStructure);
	GPIO_SetBits(GPIOE,GPIO_Pin_0|GPIO_Pin_1);
	
	
	//E2 E3 为A路电机的IN1 IN2	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2|GPIO_Pin_3;				 
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;		 //IO口速度为50MHz
	GPIO_Init(GPIOE, &GPIO_InitStructure);

	//E4 E5 为B路电机的IN1 IN2	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4|GPIO_Pin_5;				 
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;		 //IO口速度为50MHz
	GPIO_Init(GPIOE, &GPIO_InitStructure);

	//E6 E7 为C路电机的IN1 IN2	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6|GPIO_Pin_7;				 
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;		 //IO口速度为50MHz
	GPIO_Init(GPIOE, &GPIO_InitStructure);	
	
	#if 1
	//E9为PWMA引脚
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOE|RCC_APB2Periph_AFIO,ENABLE);
	GPIO_PinRemapConfig(GPIO_FullRemap_TIM1,ENABLE);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9|GPIO_Pin_11|GPIO_Pin_13;	 //TIM1_CH1 CH2 CH3、 PE.9 PE.11 PE.13端口配置
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; 		 //复用推挽输出
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;		 //IO口速度为50MHz
	GPIO_Init(GPIOE, &GPIO_InitStructure);			
	#endif
}

void Hal_Driving_PWM(void)
{
	TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
	TIM_OCInitTypeDef TIM_OCInitStruct;
	
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1,ENABLE);
		//定时器TIM1初始化
	TIM_TimeBaseStructure.TIM_Period = TIMER_40K_ARR; //设置在下一个更新事件装入活动的自动重装载寄存器周期的值	
	TIM_TimeBaseStructure.TIM_Prescaler =TIMER_40K_PSC; //设置用来作为TIMx时钟频率除数的预分频值
	TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1; //设置时钟分割:TDTS = Tck_tim
	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;  //TIM向上计数模式
	TIM_TimeBaseStructure.TIM_RepetitionCounter=0;//重复计数器为0
	TIM_TimeBaseInit(TIM1, &TIM_TimeBaseStructure); //根据指定的参数初始化TIMx的时间基数单位
      
	TIM_OCInitStruct.TIM_Pulse = TIMER_40K_ARR/2;           //设置跳变值，当计数器计数到这个值时，电平发生跳变 	
	TIM_OCInitStruct.TIM_OCMode =TIM_OCMode_PWM1 ;  //模式二cnt的值大于ccr1设置值有效
	TIM_OCInitStruct.TIM_OutputState =TIM_OutputState_Enable ;  //输出使能开启
	TIM_OCInitStruct.TIM_OCPolarity =TIM_OCPolarity_High ;//高电平有效
//  TIM_OCInitStruct.TIM_OCNPolarity = TIM_OCPolarity_High;
//  TIM_OCInitStruct.TIM_OCIdleState = TIM_OCIdleState_Set;
//  TIM_OCInitStruct.TIM_OCNIdleState = TIM_OCIdleState_Reset;  
	//TIM1_CH1 开启	
	TIM_OC1Init(TIM1,&TIM_OCInitStruct);
	TIM_OC1PreloadConfig(TIM1,TIM_OCPreload_Enable);  //重装载开启

	//TIM1_CH2 开启	
	TIM_OC2Init(TIM1,&TIM_OCInitStruct);
	TIM_OC2PreloadConfig(TIM1,TIM_OCPreload_Enable);  //重装载开启

	//TIM1_CH3 开启	
	TIM_OC3Init(TIM1,&TIM_OCInitStruct);
	TIM_OC3PreloadConfig(TIM1,TIM_OCPreload_Enable);  //重装载开启

	TIM_BDTRInitTypeDef TIM_BDTRInitStructure;

	/* Automatic Output enable, Break, dead time and lock configuration*/
	TIM_BDTRInitStructure.TIM_OSSRState = TIM_OSSRState_Enable;
	TIM_BDTRInitStructure.TIM_OSSIState = TIM_OSSIState_Enable;
	TIM_BDTRInitStructure.TIM_LOCKLevel = TIM_LOCKLevel_1;
	TIM_BDTRInitStructure.TIM_DeadTime = 5;
	TIM_BDTRInitStructure.TIM_Break = TIM_Break_Disable;
	TIM_BDTRInitStructure.TIM_BreakPolarity = TIM_BreakPolarity_High;
	TIM_BDTRInitStructure.TIM_AutomaticOutput = TIM_AutomaticOutput_Disable;

	TIM_BDTRConfig(TIM1, &TIM_BDTRInitStructure);

	/* Master Mode selection */
	TIM_SelectOutputTrigger(TIM1, TIM_TRGOSource_Update);

	/* Select the Master Slave Mode */
	TIM_SelectMasterSlaveMode(TIM1, TIM_MasterSlaveMode_Enable);

	NVIC_InitTypeDef NVIC_InitStructure;

//	//中断优先级NVIC设置
	NVIC_InitStructure.NVIC_IRQChannel = TIM1_UP_IRQn;  //TIM1更新中断
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;  //先占优先级0级
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;  //从优先级3级
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE; //IRQ通道被使能
	NVIC_Init(&NVIC_InitStructure);  //初始化NVIC寄存器
	TIM_ITConfig(TIM1,TIM_IT_Update,ENABLE ); //使能指定的TIM1中断,允许更新中断

    TIM_ARRPreloadConfig(TIM1, ENABLE);                         // 使能TIM1重载寄存器ARR    
	TIM_CtrlPWMOutputs(TIM1, ENABLE);                             //pwm输出
	TIM_Cmd(TIM1, ENABLE);  //使能TIMx		
	
}
void Hal_Driving_Periph_Init(void)
{
	Hal_Driving_IO_Init();
	Hal_Driving_PWM();
//	Hal_Encode_Exit_Config();
////	MCU_AW_DIR_BACKWORD;
//	MCU_AW_DIR_FORWORD;
////	MCU_BW_DIR_BACKWORD;
//	MCU_BW_DIR_FORWORD;
////	MCU_CW_DIR_BACKWORD;
//	MCU_CW_DIR_FORWORD;
// 	*Hal_Wheel_GetCcr_A() = 800;
// 	*Hal_Wheel_GetCcr_B() = 800;
// 	*Hal_Wheel_GetCcr_C() = 800;
//	MCU_AW_DIR_STOP;
//	MCU_BW_DIR_STOP;
//	MCU_CW_DIR_STOP;	
//	Timer_Delay_Ms(1000);
//	MCU_AW_DIR_STOP;
//	MCU_BW_DIR_STOP;
//  MCU_CW_DIR_STOP;
//	*Hal_Wheel_GetCcr_A() = 0;
// 	*Hal_Wheel_GetCcr_B() = 0;
// 	*Hal_Wheel_GetCcr_C() = 0;
}

/***********************************************************************************/

void HwWheel_Config_Wheel_A(uint8_t state)
{
	if (state)
	{
		//		Hw_A_Wheel_Enable(); //目前是长常电 不需要控制电源
		g_a_disable = 0;
	}
	else
	{
//		if(g_b_disable&&g_c_disable)
//		{
//			Hw_A_Wheel_Disable();
//		}		
		g_a_disable = 1;
	}
}

volatile uint16_t *Hal_Wheel_GetCcr_A(void)
{
	return &MCU_AW_TIM_CH;
}
void Hal_Wheel_Encoder_A_Isr(void)
{
	++g_wheel_a.undir_count;
	g_wheel_a.dir_count += (g_wheel_a.dir == 1)? 1 : -1;
}
volatile int32_t *Hal_Wheel_GetWheel_A_Addr_UndirEncoder(void)
{
	return &g_wheel_a.undir_count;
}
volatile int32_t *HwWheel_GetWheel_A_Addr_DirEncoder(void)
{
	return &g_wheel_a.dir_count;
}

void Hal_Wheel_Set_Dir_A(Wheel_Dir_t dir)
{	
	switch (dir)
	{
		case WHEEL_FORWARD:
//			MCU_LW_CTRL_HIGH;	
			MCU_AW_DIR_FORWORD;
			g_wheel_a.dir = 1;/*上报协议向前2019.10.19lyn*/
			break;
			
		case WHEEL_BACKWARD:
//			MCU_LW_CTRL_HIGH;	
			MCU_AW_DIR_BACKWORD;		
			
			g_wheel_a.dir = -1;/*上报协议向后2019.10.19lyn*/
			break;
			
		case WHEEL_STOP:/*maybe break IO*/
//			MCU_LW_BREAK_LOW;/*low break active */
//			MCU_LW_CTRL_LOW;	
			MCU_AW_TIM_CH = 0;
//			MCU_AW_TIMX->CCER   &= MCU_LW_CCER_RESET;
			break;
			
		default:
			break;
	}
}
/***********************************************************************************/

void HwWheel_Config_Wheel_B(uint8_t state)
{
	if (state)
	{
		//		Hw_B_Wheel_Enable(); //目前是长常电 不需要控制电源
		g_b_disable = 0;
	}
	else
	{
//		if(g_a_disable&&g_c_disable)
//		{
//			Hw_B_Wheel_Disable();
//		}		
		g_b_disable = 1;
	}
}

volatile uint16_t *Hal_Wheel_GetCcr_B(void)
{
	return &MCU_BW_TIM_CH;
}
void Hal_Wheel_Encoder_B_Isr(void)
{
	++g_wheel_b.undir_count;
	g_wheel_b.dir_count += (g_wheel_b.dir == 1)? 1 : -1;
}
volatile int32_t *Hal_Wheel_GetWheel_B_Addr_UndirEncoder(void)
{
	return &g_wheel_b.undir_count;
}
volatile int32_t *HwWheel_GetWheel_B_Addr_DirEncoder(void)
{
	return &g_wheel_b.dir_count;
}

void Hal_Wheel_Set_Dir_B(Wheel_Dir_t dir)
{	
	switch (dir)
	{
		case WHEEL_FORWARD:
			MCU_BW_DIR_FORWORD;
			g_wheel_b.dir = 1;
			break;
			
		case WHEEL_BACKWARD:
			MCU_BW_DIR_BACKWORD;			
			g_wheel_b.dir = -1;
			break;
			
		case WHEEL_STOP:/*maybe break IO*/
			MCU_BW_TIM_CH = 0;
			break;
			
		default:
			break;
	}
}

/***********************************************************************************/

void HwWheel_Config_Wheel_C(uint8_t state)
{
	if (state)
	{
//		Hw_C_Wheel_Enable(); //目前是长常电 不需要控制电源
		g_c_disable = 0;
	}
	else
	{
//		if(g_a_disable&&g_b_disable)
//		{
//			Hw_C_Wheel_Disable();
//		}		
		g_c_disable = 1;
	}
}

volatile uint16_t *Hal_Wheel_GetCcr_C(void)
{
	return &MCU_CW_TIM_CH;
}
void Hal_Wheel_Encoder_C_Isr(void)
{
	++g_wheel_c.undir_count;
	g_wheel_c.dir_count += (g_wheel_c.dir == 1)? 1 : -1;
}
volatile int32_t *Hal_Wheel_GetWheel_C_Addr_UndirEncoder(void)
{
	return &g_wheel_c.undir_count;
}
volatile int32_t *HwWheel_GetWheel_C_Addr_DirEncoder(void)
{
	return &g_wheel_c.dir_count;
}

void Hal_Wheel_Set_Dir_C(Wheel_Dir_t dir)
{	
	switch (dir)
	{
		case WHEEL_FORWARD:
			MCU_CW_DIR_FORWORD;
			g_wheel_c.dir = 1;
			break;
			
		case WHEEL_BACKWARD:
			MCU_CW_DIR_BACKWORD;			
			g_wheel_c.dir = -1;
			break;
			
		case WHEEL_STOP:/*maybe break IO*/
			MCU_CW_TIM_CH = 0;
			break;
			
		default:
			break;
	}
}
