#include "hal_irq_manager.h"
#include "hal_driving_wheel.h"
#include "hal_air_quality_sensor.h"
#include "global_param.h"

#ifdef __cplusplus
extern "C" {
#endif
void Exit_Null(void){};
void Dma_Null(void){};
void Uart_Null(void){};
void Timer_Null(uint32_t tim_sr){};

#define ExitIsr0   Exit_Null 
#define ExitIsr1   Exit_Null
#define ExitIsr2   Hal_Wheel_Encoder_B_Isr
#define ExitIsr3   Exit_Null
#define ExitIsr4   Exit_Null
#define ExitIsr5   Exit_Null
#define ExitIsr6   Hal_Wheel_Encoder_C_Isr 
#define ExitIsr7   Exit_Null
#define ExitIsr8   Exit_Null
#define ExitIsr9   Exit_Null
#define ExitIsr10  Exit_Null	
#define ExitIsr11  Exit_Null
#define ExitIsr12  Exit_Null	
#define ExitIsr13  Exit_Null 	
#define ExitIsr14  Exit_Null
#define ExitIsr15  Hal_Wheel_Encoder_A_Isr	
/*按照顺序排好顺序 遗漏以及错填容易造成hardfault*/	
void (*Exit_isr[])(void)=
{
	ExitIsr0,			         //0
	ExitIsr1,			         //1
	ExitIsr2,			         //2
	ExitIsr3,			         //3
	ExitIsr4,			         //4
	ExitIsr5,			         //5
	ExitIsr6,			         //6
	ExitIsr7,				   	 //7
	ExitIsr8,			         //8
	ExitIsr9,			         //9
	ExitIsr10, 				     //10
	ExitIsr11,		   			 //11
	ExitIsr12,			   	     //12
	ExitIsr13,				     //13
	ExitIsr14,					 //14
	ExitIsr15,			         //15
};



void (*Dma_Channel_isr[])(void) = 
{
	Dma_Null,              //  0
	Dma_Null,              //  1   
    Dma_Null,     //	Debug_Dma_Irq,         //  2
	Dma_Null,              //  3
	Dma_Null,//  4
	Dma_Null,              //  5
	Dma_Null,              //  6
	Dma_Null,              //  7	
};
void (*Uart_Channel_isr[])(void) = 
{
	Uart_Null,         //  0
	Uart_Null,         //  1   
	Air_Quality_Recv_Irq,         //  2   
    Uart_Null,		//  3
};
void (*Timer_Isr[])(uint32_t tim_sr) = 
{
//	Timer1_Isr,              //  0
//	Timer2_Isr,         //  1   
//  Timer6_Isr,				//  2
//	Timer14_Isr,              //  3
//	Timer15_Isr,				//  4
//	Timer16_Isr,              //  5
//	Timer17_Isr,              //  6
	Timer_Null,              //  7	
};
void Timer_AdcSample_Start(void)
{
}

void Timer_AdcSample_End(void)
{
}

void Timer1_Isr(uint32_t tim_sr)
{
	if(TIM1->SR & TIM_SR_UIF) 
	{
		TIM1->SR &= (uint16_t)~TIM_SR_UIF  ;

	}	
	if(TIM1->SR & TIM_SR_CC1IF)
	{
	   TIM1->SR &= (uint16_t)~ TIM_SR_CC1IF  ;
	}
	if(TIM1->SR & TIM_SR_CC3IF)
	{
	   TIM1->SR &= (uint16_t)~ TIM_SR_CC3IF  ;
	}		
}
void Timer1_Up_Isr(uint32_t tim_sr)
{
	if(TIM1->SR & TIM_SR_UIF) 
	{
		TIM1->SR &= (uint16_t)~TIM_SR_UIF  ;
		IRQ_FSM_TIM_CR();
	}	
}	
void Timer2_Isr(uint32_t tim_sr)
{
	if (tim_sr & TIM_SR_CC2IF)
	{
	}
	if (tim_sr & TIM_SR_CC1IF)
	{
	}	
	if (tim_sr & TIM_SR_UIF)
	{
	
	}
}
void Timer3_Isr(uint32_t tim_sr)
{

}
/*0.1ms*/
void Timer6_Isr(uint32_t tim_sr)
{
	if (tim_sr & TIM_SR_UIF)
	{
	}
}
void Timer7_Isr(uint32_t tim_sr)
{
	if (tim_sr & TIM_SR_UIF)
	{
		
	}
}

void Timer14_Isr(uint32_t tim_sr)
{

	if (tim_sr & TIM_SR_UIF)
	{

	}	
}

void Timer15_Isr(uint32_t tim_sr)
{
}

void Timer16_Isr(uint32_t tim_sr)
{	
	if (tim_sr & TIM_SR_UIF)
	{

	} 
}

void Timer17_Isr(uint32_t tim_sr)
{

}

void Rtc_Isr(void)
{
	LOG("%s(%d)\n",__FUNCTION__,__LINE__);
}
#ifdef __cplusplus
}
#endif
