#include "hal_ultrasonic.h"
#include "delay.h"
#include "oled.h"
#define TIMER_40K_ARR               7199  
#define TIMER_40K_PSC               0 
#define ULTRA_ARR TIMER_40K_ARR//0XFFFF
#define ULTRA_PSC TIMER_40K_PSC//72-1

 //以1Mhz的频率计数 =====超声波初始化
u32 distance[3]={0};
u16   capture_sta[3]={0}, capture_val[3]={0};  //输入捕获状态   //输入捕获值

static void delay_us(uint8_t cnt);
static void Echo1_Init(void);
static void Echo2_3_Init(void);
static void Read_Ultrasouic_Distane(uint8_t id);
void Ultrasouic_Cap_Init(void)
{
	Echo1_Init();
	Echo2_3_Init();
} 
void Ultrasouic_Process(void)
{
	for(uint8_t i =0;i<3;i++)
		Read_Ultrasouic_Distane(i);	
}
static void Echo1_Init(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
    TIM_TimeBaseInitTypeDef TIM_TimeBaseStructure;
    TIM_ICInitTypeDef TIM_ICInitStructure;
    NVIC_InitTypeDef NVIC_InitStructure;
    
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3,ENABLE);    /*使能TIM5时钟*/
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC,ENABLE); 

	GPIO_PinRemapConfig(GPIO_FullRemap_TIM3,ENABLE);
    
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9; /**/
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPD; /*PA0 输入*/
    GPIO_Init(GPIOC,&GPIO_InitStructure);
    GPIO_ResetBits(GPIOC,GPIO_Pin_9); /*PA0 下拉*/
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8;//trig
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOC, &GPIO_InitStructure); 
    
    /*初始化定时器5 TIM5*/
    TIM_TimeBaseStructure.TIM_Period = ULTRA_ARR; /*设定计数器自动重装值 */
    TIM_TimeBaseStructure.TIM_Prescaler = ULTRA_PSC; /*预分频器 */
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1; /*设置时钟分割:TDTS = Tck_tim*/
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up; /*TIM向上计数模式*/
    TIM_TimeBaseInit(TIM3,&TIM_TimeBaseStructure); /*根据TIM_TimeBaseInitStruct中指定的参数初始化TIMx的时间基数单位*/
            
    /* 初始化TIM5输入捕获参数 */
    TIM_ICInitStructure.TIM_Channel = TIM_Channel_4; /*CC1S=01     选择输入端 IC1映射到TI1上*/    
    TIM_ICInitStructure.TIM_ICPolarity = TIM_ICPolarity_Rising; /*上升沿捕获*/
    TIM_ICInitStructure.TIM_ICSelection = TIM_ICSelection_DirectTI; /*映射到TI1上*/
    TIM_ICInitStructure.TIM_ICPrescaler = TIM_ICPSC_DIV1; /*配置输入分频,不分频*/
    TIM_ICInitStructure.TIM_ICFilter = 0; /*IC1F=0000 配置输入滤波器 不滤波*/
    TIM_ICInit(TIM3,&TIM_ICInitStructure); 
//输入预分频。意思是控制在多少个输入周期做一次捕获，如果  
//输入的信号频率没有变，测得的周期也不会变。比如选择4分频，则每四个输入周期才做一次捕获，这样在输入信号变化不频繁的情况下，    


    /*中断分组初始化*/
//    NVIC_InitStructure.NVIC_IRQChannel = TIM3_IRQn;    /*TIM5中断*/
//    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2; /*先占优先级2级*/
//    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0; /*从优先级0级*/
//    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE; /*IRQ通道被使能*/
//    NVIC_Init(&NVIC_InitStructure);
    
//		TIM_SelectInputTrigger(TIM5,TIM_TS_TI1FP1);//参考TIM结构图选择滤波后的TI1输入作为触发源，触发下面程序的复位
//		TIM_SelectSlaveMode(TIM5,TIM_SlaveMode_Reset);//复位模式-选中的触发输入（TRGI）的上升沿初始化计数器，并且产生一个更新线号

//    TIM_ITConfig(TIM3,TIM_IT_Update|TIM_IT_CC1,ENABLE);/*允许更新中断 ,允许CC1IE捕获中断*/
    TIM_SetCounter(TIM3,0);
	TIM_Cmd(TIM3,ENABLE); /*使能定时器5*/  	
}
static void Echo2_3_Init(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
    TIM_TimeBaseInitTypeDef TIM_TimeBaseStructure;
    TIM_ICInitTypeDef TIM_ICInitStructure;
    NVIC_InitTypeDef NVIC_InitStructure;
    
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM4,ENABLE);    /*使能TIM5时钟*/
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD,ENABLE); 

	GPIO_PinRemapConfig(GPIO_Remap_TIM4,ENABLE);
    
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13 ; /*2*/
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPD; /*PA0 输入*/
    GPIO_Init(GPIOD,&GPIO_InitStructure);
    GPIO_ResetBits(GPIOD,GPIO_Pin_13); /*PA0 下拉*/
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;//trig
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOD, &GPIO_InitStructure); 
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_15 ; /*3*/
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPD; /*PA0 输入*/
    GPIO_Init(GPIOD,&GPIO_InitStructure);
    GPIO_ResetBits(GPIOD,GPIO_Pin_15); /*PA0 下拉*/
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_14;//trig
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOD, &GPIO_InitStructure); 
    
    /*初始化定时器5 TIM5*/
    TIM_TimeBaseStructure.TIM_Period = ULTRA_ARR; /*设定计数器自动重装值 */
    TIM_TimeBaseStructure.TIM_Prescaler = ULTRA_PSC; /*预分频器 */
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1; /*设置时钟分割:TDTS = Tck_tim*/
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up; /*TIM向上计数模式*/
    TIM_TimeBaseInit(TIM4,&TIM_TimeBaseStructure); /*根据TIM_TimeBaseInitStruct中指定的参数初始化TIMx的时间基数单位*/
            
    /* 初始化TIM5输入捕获参数 */
    TIM_ICInitStructure.TIM_Channel = TIM_Channel_2; /*2  CC1S=01     选择输入端 IC1映射到TI1上*/    
    TIM_ICInitStructure.TIM_ICPolarity = TIM_ICPolarity_Rising; /*上升沿捕获*/
    TIM_ICInitStructure.TIM_ICSelection = TIM_ICSelection_DirectTI; /*映射到TI1上*/
    TIM_ICInitStructure.TIM_ICPrescaler = TIM_ICPSC_DIV1; /*配置输入分频,不分频*/
    TIM_ICInitStructure.TIM_ICFilter = 0; /*IC1F=0000 配置输入滤波器 不滤波*/
    TIM_ICInit(TIM4,&TIM_ICInitStructure); 
	
    TIM_ICInitStructure.TIM_Channel = TIM_Channel_4; /*3  CC1S=01     选择输入端 IC1映射到TI1上*/    
    TIM_ICInitStructure.TIM_ICPolarity = TIM_ICPolarity_Rising; /*上升沿捕获*/
    TIM_ICInitStructure.TIM_ICSelection = TIM_ICSelection_DirectTI; /*映射到TI1上*/
    TIM_ICInitStructure.TIM_ICPrescaler = TIM_ICPSC_DIV1; /*配置输入分频,不分频*/
    TIM_ICInitStructure.TIM_ICFilter = 0; /*IC1F=0000 配置输入滤波器 不滤波*/
    TIM_ICInit(TIM4,&TIM_ICInitStructure); 	
//输入预分频。意思是控制在多少个输入周期做一次捕获，如果  
//输入的信号频率没有变，测得的周期也不会变。比如选择4分频，则每四个输入周期才做一次捕获，这样在输入信号变化不频繁的情况下，    


    /*中断分组初始化*/
    NVIC_InitStructure.NVIC_IRQChannel = TIM4_IRQn;    /*TIM5中断*/
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2; /*先占优先级2级*/
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0; /*从优先级0级*/
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE; /*IRQ通道被使能*/
    NVIC_Init(&NVIC_InitStructure);
    
//		TIM_SelectInputTrigger(TIM5,TIM_TS_TI1FP1);//参考TIM结构图选择滤波后的TI1输入作为触发源，触发下面程序的复位
//		TIM_SelectSlaveMode(TIM5,TIM_SlaveMode_Reset);//复位模式-选中的触发输入（TRGI）的上升沿初始化计数器，并且产生一个更新线号

//    TIM_ITConfig(TIM4,TIM_IT_Update|TIM_IT_CC1,ENABLE);/*允许更新中断 ,允许CC1IE捕获中断*/
//    TIM_SetCounter(TIM4,0);
//	TIM_Cmd(TIM4,ENABLE); /*使能定时器5*/ 	
}

void Read_Ultrasouic_Distane(uint8_t id)
{
	switch(id)
	{
		case 0:
		PCout(8)=1;
		delay_us(150);
		PCout(8)=0;
		break;
		case 1:
		PDout(12)=1;
		delay_us(150);
		PDout(12)=0;
		break;
		case 2:
		PDout(14)=1;
		delay_us(150);
		PDout(14)=0;
		break;
		default:
			break;
	}
	if(capture_sta[id]&0X80)//成功捕获到了一次上升沿
	{
			distance[id]=capture_sta[id]&0X3F;
			distance[id]*=65536;//溢出时间总和
			distance[id]+=capture_val[id];//得到总的高电平时间
			distance[id]=distance[id]*170/10000;
//			LOG("%d cm\r\n",distance);	
			OLED_ShowString(0,3,"distance:");
			OLED_ShowNum(50,6,distance[id],4,16);
			OLED_ShowString(75,6,"cm");					
			capture_sta[0]=0;//开启下一次捕获
	}
}

/**
 * 定时器5中断服务程序     
 */
void TIM3_IRQHandler(void)
{ 
    if((capture_sta[0]&0X80)==0)//还未成功捕获    
    {
        if(TIM_GetITStatus(TIM3,TIM_IT_Update) != RESET)
        {
			TIM_ClearITPendingBit(TIM3,TIM_IT_Update); /*清除中断标志位*/			
            if(capture_sta[0]&0X40)//已经捕获到高电平了
            {
                if((capture_sta[0]&0X3F)==0X3F)//高电平太长了
                {
                    capture_sta[0]|=0X80;//标记成功捕获了一次
                    capture_val[0]=0XFFFF;
                }else capture_sta[0]++;
            }
        }
        
        if(TIM_GetITStatus(TIM3,TIM_IT_CC4) !=RESET)
        {
			TIM_ClearITPendingBit(TIM3,TIM_IT_CC4); /*清除中断标志位*/						
            if(capture_sta[0] & 0x40)
            {
                capture_sta[0]|=0X80;        //标记成功捕获到一次上升沿
                capture_val[0] = TIM_GetCounter(TIM3);
                TIM_OC4PolarityConfig(TIM3,TIM_ICPolarity_Rising); //CC1P=0 设置为上升沿捕获
            }
            else
            {
                capture_sta[0]=0;            //清空
                capture_val[0]=0;
                
                TIM_SetCounter(TIM3,0);
                capture_sta[0]|=0X40;        //标记捕获到了上升沿
                TIM_OC4PolarityConfig(TIM3,TIM_ICPolarity_Falling);        //CC1P=1 设置为下降沿捕获
            }
        }
        
    }
}
void TIM4_IRQHandler(void)
{
  if((capture_sta[1]&0X80)==0||(capture_sta[2]&0X80)==0)//还未成功捕获    
    {
        if(TIM_GetITStatus(TIM4,TIM_IT_Update) != RESET)
        {
 			TIM_ClearITPendingBit(TIM4,TIM_IT_Update); /*清除中断标志位*/						
           if(capture_sta[1]&0X40)//已经捕获到高电平了
            {
                if((capture_sta[1]&0X3F)==0X3F)//高电平太长了
                {
                    capture_sta[1]|=0X80;//标记成功捕获了一次
                    capture_val[1]=0XFFFF;
                }else capture_sta[1]++;
            }
            if(capture_sta[2]&0X40)//已经捕获到高电平了
            {
                if((capture_sta[2]&0X3F)==0X3F)//高电平太长了
                {
                    capture_sta[2]|=0X80;//标记成功捕获了一次
                    capture_val[2]=0XFFFF;
                }else capture_sta[2]++;
            }
        }
        
        if(TIM_GetITStatus(TIM4,TIM_IT_CC2) !=RESET)
        {
 		   TIM_ClearITPendingBit(TIM4,TIM_IT_CC2); /*清除中断标志位*/						
           if(capture_sta[1] & 0x40)
            {
                capture_sta[1]|=0X80;        //标记成功捕获到一次上升沿
                capture_val[1] = TIM_GetCounter(TIM4);
                TIM_OC2PolarityConfig(TIM4,TIM_ICPolarity_Rising); //CC1P=0 设置为上升沿捕获
            }
            else
            {
                capture_sta[1]=0;            //清空
                capture_val[1]=0;
                
                TIM_SetCounter(TIM4,0);
                capture_sta[1]|=0X40;        //标记捕获到了上升沿
                TIM_OC2PolarityConfig(TIM4,TIM_ICPolarity_Falling);        //CC1P=1 设置为下降沿捕获
            }
        }
        if(TIM_GetITStatus(TIM4,TIM_IT_CC4) !=RESET)
        {
 		   TIM_ClearITPendingBit(TIM4,TIM_IT_CC4); /*清除中断标志位*/						
           if(capture_sta[2] & 0x40)
            {
                capture_sta[2]|=0X80;        //标记成功捕获到一次上升沿
                capture_val[2] = TIM_GetCounter(TIM4);
                TIM_OC4PolarityConfig(TIM4,TIM_ICPolarity_Rising); //CC1P=0 设置为上升沿捕获
            }
            else
            {
                capture_sta[2]=0;            //清空
                capture_val[2]=0;
                
                TIM_SetCounter(TIM4,0);
                capture_sta[2]|=0X40;        //标记捕获到了上升沿
                TIM_OC4PolarityConfig(TIM4,TIM_ICPolarity_Falling);        //CC1P=1 设置为下降沿捕获
            }
        }       
    }		
}
#if RT_THREAD
#include "rtthread.h"
#endif

static void delay_us(uint8_t cnt)
{
	#if RT_THREAD
	rt_thread_delay(cnt);		
	#else
	while(cnt--);
	#endif
}








