#include "external_flash.h"
#include "w25qxx.h"	 
#include "oled.h"
#include "LD3320_Driver.h"
#include "mp3.h"

//要写入到W25Q64的字符串数组
u8 TEXT_Buffer[]={"WarShipSTM32 SPI TEST"};
#define SIZE sizeof(TEXT_Buffer)
u32 FLASH_SIZE =256*1024*1024;	//FLASH 大小为32M字节

void External_Flash_Init(void)
{
	W25QXX_Init();			//W25QXX初始化
}
void External_Flash_Process(void)
{
	OLED_Clear();
	if(W25QXX_ReadID()!=W25Q256)								//检测不到W25Q128
	{
		OLED_ShowString(1,16,(const unsigned char*)"W25Q128 Check Failed!"); 
		return;
	}
	OLED_ShowString(1,48,(const unsigned char*)"W25Q128 Ready!");    
	u8 key;
	u8 datatemp[SIZE];
	if(key==1)	//KEY1按下,写入W25QXX
	{
		OLED_ShowString(1,32,(const unsigned char*)"Start Write W25Q128...."); 
		W25QXX_Write((u8*)TEXT_Buffer,0,10);			//从倒数第100个地址处开始,写入SIZE长度的数据
		OLED_ShowString(1,32,(const unsigned char*)"W25Q128 Write Finished!");	//提示传送完成
	}
	if(key==2)	//KEY0按下,读取字符串并显示
	{
		OLED_ShowString(1,16,(const unsigned char*)"Start Read W25Q128.... ");
		W25QXX_Read(datatemp,FLASH_SIZE-100,SIZE);					//从倒数第100个地址处开始,读出SIZE个字节
		OLED_ShowString(1,32,(const unsigned char*)"The Data Readed Is:  ");	//提示传送完成
		OLED_ShowString(1,48,datatemp);//显示读到的字符串
	}		   
}



