#include "voice_interaction.h"
#include "delay.h"
#include "LD3320_Process.h"
#include "LD3320_Driver.h"
#include "robot_ctrl.h"

#if RT_THREAD
#include "board.h"
#include "rtthread.h"
#include "speaker.h"
extern rt_event_t speak_task_event;
#endif

UBYTE nAsrRes = 0;
void Voice_Iteraction_Init(void )
{
	LD_Peripheral_Init();
	LD_init();		
}

void Voice_Iteraction_Process(void)
{
	static bool Level_1_instruction =false;
		if(bMp3Play) {
			LOG("*********playing*********\r\n");
			return;
		}
		//LOG("nAsrStatus is %x, nLD_Mode is %x \r\n", nAsrStatus, nLD_Mode);
		switch(nAsrStatus) {
			case LD_ASR_RUNING:
			case LD_ASR_ERROR:		
				break;
			case LD_ASR_NONE:
				nAsrStatus=LD_ASR_RUNING;
				if (LD_ASR()==0)//Start the ASR process once	
					nAsrStatus = LD_ASR_ERROR;
				break;
			case LD_ASR_FOUNDOK:
				nAsrRes = LD_GetResult();//once ASR process end, get the result									 	 										
				 if(nAsrRes==CODE_RUN)
				 {
					 	LOG("first receive \r\n");
						Level_1_instruction=true;
						Task_Respose();	
//						#if RT_THREAD
//					 	rt_event_send(speak_task_event,ResposeSta);    	
//						#endif					 
				 }

//				 else if(Level_1_instruction == true)
				 {
					 Level_1_instruction=false;
					switch(nAsrRes) {//show the commond
						case CODE_AIR_QUALITY:
							Task_Air_Quality();
//							#if RT_THREAD
//							rt_event_send(speak_task_event,AirQualitySta);    	
//							#endif	
							LOG("CODE_AIR_QUALITY\r\n"); 
							break;
						case CODE_PLAY_TIME:			
							Task_Time();
//							#if RT_THREAD
//							rt_event_send(speak_task_event,RealTimeSta);    	
//							#endif	
							break;	
						case CODE_FORWARD:	
							Task_Forward();	
//							#if RT_THREAD
//							rt_event_send(speak_task_event,RobotForwardSta);    	
//							#endif							
							LOG("CODE_FORWARD\r\n"); 
							break;
						case CODE_BACKWARD:
							Task_Backward();
//							#if RT_THREAD
//							rt_event_send(speak_task_event,RobotBackwardSta);    	
//							#endif							
							LOG("CODE_BACKWARD\r\n"); 
							break;

						case CODE_TURNLEFT:		
							Task_Turn_Left();
//							#if RT_THREAD
//							rt_event_send(speak_task_event,RobotTurnLeftSta);    	
//							#endif							
							LOG("CODE_TURNLEFT\r\n"); 
							break;
						case CODE_TURNRIGHT:	
							Task_Turn_Right();
//							#if RT_THREAD
//							rt_event_send(speak_task_event,RobotTurnRightSta);    	
//							#endif							
							LOG("CODE_TURNRIGHT\r\n"); 
							break;	
						case CODE_MUSIC:
							Task_Music();
//							rt_event_send(speak_task_event,RobotMusic);    	
							break;
						case CODE_NEXT_MUSIC:
							Task_Next_Music();
//							rt_event_send(speak_task_event,RobotNextMusic);    	
							break;
						case CODE_PREVIOUS_MUSIC:
							Task_Previous_Music();
//							rt_event_send(speak_task_event,RobotPreviousMusic);    	
							break;
						default:
							break;
					}	
					nAsrStatus = LD_ASR_NONE;
					break;
				}
			case LD_ASR_FOUNDZERO:
			default:
				nAsrStatus = LD_ASR_NONE;
				break;
		}
//		Board_text(nAsrRes);//do the commond
//		nAsrRes=0;
		
}
