/**
  ******************************************************************************
  * @file    HK32F10x_StdPeriph_Template/hk32f10x_it.c 
  * @version V1.0.0
  * @date    2019-08-05
  * @brief   Main Interrupt Service Routines.
  *          This file provides template for all exceptions handler and 
  *          peripherals interrupt service routine.
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "hk32f10x_it.h"
#include "hal_irq_manager.h"
#include "delay.h"
#include "hal_air_quality_sensor.h"

/** @addtogroup HK32F10x_StdPeriph_Template
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/******************************************************************************/
/*            Cortex-M3 Processor Exceptions Handlers                         */
/******************************************************************************/

/**
  * @brief  This function handles NMI exception.
  * @param  None
  * @retval None
  */
void NMI_Handler(void)
{
}
#if 0
/**
  * @brief  This function handles Hard Fault exception.
  * @param  None
  * @retval None
  */
void HardFault_Handler(void)
{
  /* Go to infinite loop when Hard Fault exception occurs */
  while (1)
  {
  }
}
#endif
/**
  * @brief  This function handles Memory Manage exception.
  * @param  None
  * @retval None
  */
void MemManage_Handler(void)
{
  /* Go to infinite loop when Memory Manage exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles Bus Fault exception.
  * @param  None
  * @retval None
  */
void BusFault_Handler(void)
{
  /* Go to infinite loop when Bus Fault exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles Usage Fault exception.
  * @param  None
  * @retval None
  */
void UsageFault_Handler(void)
{
  /* Go to infinite loop when Usage Fault exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles SVCall exception.
  * @param  None
  * @retval None
  */

void SVC_Handler(void)
{
}


/**
  * @brief  This function handles Debug Monitor exception.
  * @param  None
  * @retval None
  */
void DebugMon_Handler(void)
{
}
#if 0
/**
  * @brief  This function handles PendSVC exception.
  * @param  None
  * @retval None
  */

void PendSV_Handler(void)
{
}
#endif

/******************************************************************************/
/*                 HK32F10x Peripherals Interrupt Handlers                   */
/*  Add here the Interrupt Handler for the used peripheral(s) (PPP), for the  */
/*  available peripheral interrupt handler's name please refer to the startup */
/*  file (startup_hk32f10x_xx.s).                                            */
/******************************************************************************/

/**
  * @brief  This function handles PPP interrupt request.
  * @param  None
  * @retval None
  */
/*void PPP_IRQHandler(void)
{
}*/
#if 0
/**
  * @}
  */ 
/**
  * @brief  This function handles SysTick exception.
  * @param  None
  * @retval None
  */
void SysTick_Handler(void)
{
	Systick_Isr();
}
#endif
/***************************************************************************/
#if 0
void RTC_IRQHandler(void)
{
	if (RTC_GetITStatus(RTC_IT_ALR) != RESET)
	{
		RTC_ClearITPendingBit(RTC_IT_ALR|RTC_IT_SEC|RTC_IT_OW);		
		EXTI->PR |= EXTI_PR_PR17;     /* clear exti line 17 flag */
		Rtc_Isr();
	}
}
#endif
/****************************************************/
void TIM1_CC_IRQHandler(void)
{
	const uint32_t sr = (TIM1->SR & 0x1f);
//	TIM1->SR = ~sr;	
	Timer1_Isr(sr);
}
void TIM1_TRG_COM_IRQHandler(void)
{
	const uint32_t sr = (TIM1->SR & 0x1f);	
	TIM1->SR = ~sr;	
	Timer1_Isr(sr);
}
void TIM1_UP_IRQHandler(void)
{
	const uint32_t sr = (TIM1->SR & 0x1f);	
//	TIM1->SR = ~sr;	
	Timer1_Up_Isr(sr);	
}
void TIM1_BRK_IRQHandler(void)
{
	const uint32_t sr = (TIM1->SR & 0x1f);	
//	TIM1->SR = ~sr;	
	Timer1_Up_Isr(sr);
}
void TIM2_IRQHandler(void)
{
	const uint32_t sr = (TIM2->SR & 0x1f);
//	TIM2->SR = ~sr;
	Timer2_Isr(sr);
}
//void TIM4_IRQHandler(void)
//{
//	const uint32_t sr = (TIM4->SR & 0x1f);
//	TIM4->SR = ~sr;
//	Timer2_Isr(sr);
//}


/*--------------- CHARGER_V_DETECT----------------------------------------------*/
void EXTI0_IRQHandler(void)
{
	const uint32_t pr = EXTI->PR;
	EXTI->PR = 0x01;
	if (pr & EXTI_PR_PR0)
	{
		Exit_isr[0]();
	}
}
//void EXTI1_IRQHandler(void)
//{
//	const uint32_t pr = EXTI->PR;
//	EXTI->PR = 0x02;
//	if (pr & EXTI_PR_PR1)
//	{
//		Exit_isr[1]();
//	} 
//}
void EXTI2_IRQHandler(void)
{
	const uint32_t pr = EXTI->PR;
	if (pr & EXTI_PR_PR2)
	{
		EXTI->PR = EXTI_PR_PR2;
		Exit_isr[2]();
	}
}
void EXTI3_IRQHandler(void)
{
	const uint32_t pr = EXTI->PR;
	if (pr & EXTI_PR_PR3)
	{
		EXTI->PR = EXTI_PR_PR3;
		Exit_isr[3]();
	}
}
void EXTI4_IRQHandler(void)
{
	const uint32_t pr = EXTI->PR;
	if (pr & EXTI_PR_PR4)
	{
		EXTI->PR = EXTI_PR_PR4;
		Exit_isr[4]();
	}
}
void EXTI9_5_IRQHandler(void)//15042 870 14998
{
	const uint32_t pr = EXTI->PR;
//	EXTI->PR = 0xFFF0;
	if (pr & EXTI_PR_PR5)
	{
		EXTI->PR = EXTI_PR_PR5;
		Exit_isr[5]();
	}
	if (pr & EXTI_PR_PR6)
	{
		EXTI->PR = EXTI_PR_PR6;
		Exit_isr[6]();
	}
	if (pr & EXTI_PR_PR7)
	{
		EXTI->PR = EXTI_PR_PR7;
		Exit_isr[7]();
	}
	if (pr & EXTI_PR_PR8)
	{
		EXTI->PR = EXTI_PR_PR8;
		Exit_isr[8]();
	}
	if (pr & EXTI_PR_PR9)
	{
		EXTI->PR = EXTI_PR_PR9;
		Exit_isr[9]();
	}
}
void EXTI15_10_IRQHandler(void)
{
	const uint32_t pr = EXTI->PR;
	if (pr & EXTI_PR_PR10)
	{
		EXTI->PR = EXTI_PR_PR10;
		Exit_isr[10]();
	}
	if (pr & EXTI_PR_PR11)
	{
		EXTI->PR = EXTI_PR_PR11;
		Exit_isr[11]();
	}
	if (pr & EXTI_PR_PR12)
	{
		EXTI->PR = EXTI_PR_PR12;
		Exit_isr[12]();
	}
	if (pr & EXTI_PR_PR13)
	{
		EXTI->PR = EXTI_PR_PR13;
		Exit_isr[13]();
	}
	if (pr & EXTI_PR_PR14)
	{
		EXTI->PR = EXTI_PR_PR14;
		Exit_isr[14]();
	}	
	if (pr & EXTI_PR_PR15)
	{
		EXTI->PR = EXTI_PR_PR15;
		Exit_isr[15]();
	}	
}
/****************************************************/
void DMA1_Ch1_IRQHandler(void)
{
	const uint32_t pr = DMA1->ISR;
	
	DMA1->IFCR = 0x2;	
	if (pr & DMA_ISR_TCIF1)
	{
		Dma_Channel_isr[0]();		
	}
}
void DMA1_Ch2_3_DMA2_Ch1_2_IRQHandler(void)
{
	const uint32_t pr = DMA1->ISR;
	
	DMA1->IFCR = 0x220;
	
	if (pr & DMA_ISR_TCIF2) 
	{
		Dma_Channel_isr[2]();
	}
	
	if (pr & DMA_ISR_TCIF3)
	{
		Dma_Channel_isr[3]();
	}
}


void DMA1_Ch4_7_DMA2_Ch3_5_IRQHandler(void)
{
	const uint32_t pr = DMA1->ISR;

	DMA1->IFCR = 0x2222000;
	
	if (pr & DMA_ISR_TCIF3)/*DMA2 ch3*/
	{ 
		Dma_Channel_isr[3]();
	}
	
	if (pr & DMA_ISR_TCIF4) 
	{
		Dma_Channel_isr[4]();
	}
	
	if (pr & DMA_ISR_TCIF5)
	{
		Dma_Channel_isr[5]();
	}
	
	if (pr & DMA_ISR_TCIF6)
	{
		Dma_Channel_isr[6]();
	}
	
	if (pr & DMA_ISR_TCIF7)
	{
		Dma_Channel_isr[7]();
	}
}
//void USART1_IRQHandler(void)
//{
//	Uart_Channel_isr[0]();
//}
void USART2_IRQHandler(void)
{
	Uart_Channel_isr[1]();
}
void USART3_IRQHandler(void)
{
	Uart_Channel_isr[2]();
}
void UART4_IRQHandler(void)
{
	Uart_Channel_isr[3]();
}


/******************* (C) COPYRIGHT   HKMicroChip *****END OF FILE****/
