#ifndef _robot_ctrl_
#define _robot_ctrl_
#ifdef __cplusplus
extern "C" {
#endif
#include "main.h"
#include "driving_wheel.h"

void System_Init(void);
void System_Process(void);
#define	MAINFEST_MOTOR_WHEEL      0x0001
#define MAINFEST_MOTOR_BRUSH      0x0002
#define MAINFEST_MOTOR_MAINBRUSH  0x0004
#define MAINFEST_MOTOR_VACUUM     0x0008

#define MAINFEST_MOTOR_WIND       0x0010
#define MAINFEST_EVENT_LED     	  0x0020

#define MAINFEST_EVENT_BUTTON     0x0100
#define MAINFEST_EVENT_BUMPER     0x0200
#define MAINFEST_EVENT_SCAN_WALL  0x0400
#define MAINFEST_EVENT_REMOTE     0x0800

#define MAINFEST_EVENT_CLCOK      0x1000
#define MAINFEST_EVENT_RCON       0x2000
#define MAINFEST_EVENT_BATTERY    0x4000
#define MAINFEST_EVENT_CHARGE     0x8000

#define MAINFEST_EVENT_SUSPEND    0x10000
#define MAINFEST_EVENT_CLIFF      0x20000

enum { MANIFEST_APPIDLE = 
				  MAINFEST_EVENT_BUTTON     
				| MAINFEST_EVENT_BUMPER     
				| MAINFEST_EVENT_SCAN_WALL        
				| MAINFEST_EVENT_REMOTE     
				| MAINFEST_EVENT_CLCOK      
				| MAINFEST_EVENT_RCON       
				| MAINFEST_EVENT_BATTERY    
				| MAINFEST_EVENT_CHARGE  
				| MAINFEST_EVENT_LED
				| MAINFEST_EVENT_CLIFF
};

enum { MANIFEST_APPWORK = 
				  MAINFEST_MOTOR_WHEEL      
				| MAINFEST_MOTOR_BRUSH      
				| MAINFEST_MOTOR_MAINBRUSH  
				| MAINFEST_MOTOR_VACUUM            

				| MAINFEST_EVENT_BUTTON     
				| MAINFEST_EVENT_BUMPER     
				| MAINFEST_EVENT_SCAN_WALL        
				| MAINFEST_EVENT_REMOTE     
				| MAINFEST_EVENT_CLCOK      
				| MAINFEST_EVENT_RCON       
				| MAINFEST_EVENT_BATTERY    
				| MAINFEST_EVENT_CHARGE  
				| MAINFEST_EVENT_SUSPEND
				| MAINFEST_EVENT_CLIFF
				| MAINFEST_EVENT_LED
};

enum { MANIFEST_APPCHARGE = 
				  MAINFEST_EVENT_REMOTE     
				| MAINFEST_EVENT_CLCOK      
				| MAINFEST_EVENT_BUTTON          
				| MAINFEST_EVENT_BATTERY    
				| MAINFEST_EVENT_CHARGE     
};

enum { MANIFEST_APPSLEEP = 
				  MAINFEST_EVENT_REMOTE     
				| MAINFEST_EVENT_CLCOK      
				| MAINFEST_EVENT_BUTTON          
				| MAINFEST_EVENT_BATTERY    
				| MAINFEST_EVENT_CHARGE     
};

typedef	enum
{
	Dev_ID_NORMALE_SLEEP = 0,
	Dev_ID_FULL_SLEEP ,
	Dev_ID_WORK ,
	Dev_ID_IDLE,	
	Dev_ID_CHARGE ,
	Dev_ID_SLEEP ,
	Dev_ID_TEST,
	Dev_ID_UPDATA =25 ,

	Dev_ID_Invalid = 0xFF,	
}DevMode_t;
typedef struct 
{	
	DevMode_t dev_mode;
	uint32_t manifest_robot;		
	HwWheel_t wheel;
	
}Robot_t;

extern Robot_t Robot;/*全局变量2019.10.17yn*/

static inline Robot_t* Robot_Get_Base(void)
{
	return &Robot;
}
void Task_Respose(void);
void Task_Air_Quality(void);
void Task_Time(void);
void Task_Forward(void);
void Task_Backward(void);
void Task_Turn_Left(void);
void Task_Turn_Right(void);
void Task_Music(void);
void Task_Next_Music(void);
void Task_Previous_Music(void);
#ifdef __cplusplus
}
#endif

#endif
