#include "speaker.h"
#include "voice_interaction.h"
#include "delay.h"
#include "LD3320_Process.h"
#include "LD3320_Driver.h"
#if RT_THREAD

#include "board.h"
#include "rtthread.h"

static rt_thread_t speaker_thread = RT_NULL;

static void speaker_thread_entry(void* parameter);
rt_event_t speak_task_event = RT_NULL;

int Speaker_thread_Init(void)
{	
/****************thread need ********************/

	
	speak_task_event = rt_event_create("speak_task_event",/* ¼־ */
                        RT_IPC_FLAG_PRIO); /* ¼ģʽ FIFO(0x00)*/
  if (speak_task_event != RT_NULL)
    rt_kprintf("event init ok\n\n");	
/********************************************************/
	speaker_thread=
	  rt_thread_create("speaker_process",
	                   speaker_thread_entry,
	                   RT_NULL,
	                   512,
	                   0,
	                   20);

	if(speaker_thread != RT_NULL)
		rt_thread_startup(speaker_thread);
	else
		return -1;
	return 0;

}
void speaker_thread_entry(void* paramter)
{

	rt_uint32_t speak_task_event_recved;
	Voice_Iteraction_Init();
	
	while(1)
	{
     rt_event_recv(speak_task_event,  /* ¼ */
                   ResposeSta|RealTimeSta|AirQualitySta|RobotForwardSta|
					RobotBackwardSta|RobotTurnLeftSta|RobotTurnRightSta|RobotMusic|RobotNextMusic|RobotPreviousMusic,
                   RT_EVENT_FLAG_OR|RT_EVENT_FLAG_CLEAR,/* ѡ */
                   RT_WAITING_FOREVER,/* ָʱ¼,һֱ */
                   &speak_task_event_recved);    /* ָյ¼ */
	switch((Speaker_Task_Def)speak_task_event_recved)
	{
		case ResposeSta:			
			Task_Respose();
			LOG("ResposeSta\r\n"); 
			break;				

		case AirQualitySta:
			Task_Air_Quality();
			LOG("AirQualitySta\r\n"); 
			break;
		case RealTimeSta:			
			Task_Time();
			LOG("RealTimeSta\r\n"); 
			break;	
		case RobotForwardSta:	
			Task_Forward();							
			LOG("RobotForwardSta\r\n"); 
			break;
		case RobotBackwardSta:
			Task_Backward();							
			LOG("RobotBackwardSta\r\n"); 
			break;

		case RobotTurnLeftSta:		
			Task_Turn_Left();							
			LOG("RobotTurnLeftSta\r\n"); 
			break;
		case RobotTurnRightSta:	
			Task_Turn_Right();							
			LOG("RobotTurnRightSta\r\n"); 
			break;		
		case RobotMusic:
			Task_Music();
			LOG("RobotMusic\r\n"); 
		break;
		case RobotNextMusic:
			Task_Next_Music();
			LOG("RobotNextMusic\r\n"); 
			break;
		case RobotPreviousMusic:
			Task_Previous_Music();
			LOG("RobotPreviousMusic\r\n"); 
		break;		
		}
//		rt_thread_delay(100);
		rt_kprintf("speaker\n");	
		rt_thread_yield();  //ʣʱƬ		
	}
}
#endif
